> For the complete documentation index, see [llms.txt](https://docs.pyck.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pyck.cloud/graphql-api/queries/nodepicking.md).

# NodePicking

nodePicking Query

Audience: Programmer

Fetches a picking-related object given its ID. This query follows the Relay Global Object Identification Specification and can retrieve any object that implements the NodePicking interface.

## Arguments

| Name | Type  | Description                                             |
| ---- | ----- | ------------------------------------------------------- |
| `id` | `ID!` | The unique identifier of the picking object to retrieve |

## Return Type

`NodePicking` - An interface that returns an object implementing the NodePicking interface. This includes:

* `PickingOrder` - A picking order containing items to be picked
* `PickingOrderItem` - Individual item within a picking order

## Usage Example

### GraphQL Query

```graphql
query GetPickingObject($id: ID!) {
  nodePicking(id: $id) {
    id
    ... on PickingOrder {
      name
      status
      type
      data
      pickingSystemData
      createdAt
      updatedAt
      pickingorderitems {
        edges {
          node {
            id
            quantity
            status
            item {
              sku
            }
          }
        }
      }
    }
    ... on PickingOrderItem {
      quantity
      status
      item {
        sku
        data
      }
      pickingOrder {
        name
        status
      }
    }
  }
}
```

### Query Variables

```json
{
  "id": "UGlja2luZ09yZGVyOjEyMw=="
}
```

### JavaScript Example

```javascript
const getPickingObject = async (objectId) => {
  const query = `
    query GetPickingObject($id: ID!) {
      nodePicking(id: $id) {
        id
        __typename
        ... on PickingOrder {
          name
          status
          type
          data
          createdAt
          updatedAt
        }
        ... on PickingOrderItem {
          quantity
          status
          item {
            sku
          }
          pickingOrder {
            name
          }
        }
      }
    }
  `;

  const response = await fetch('/graphql', {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
      'Authorization': `Bearer ${accessToken}`
    },
    body: JSON.stringify({
      query,
      variables: { id: objectId }
    })
  });

  const { data } = await response.json();
  return data.nodePicking;
};
```

## Type Detection

Use the `__typename` field to determine which specific type was returned:

```javascript
const object = await getPickingObject(id);
switch (object.__typename) {
  case 'PickingOrder':
    console.log(`Picking Order: ${object.name}`);
    break;
  case 'PickingOrderItem':
    console.log(`Order Item SKU: ${object.item.sku}`);
    break;
}
```

## Related

* [NodePicking Interface](https://github.com/pyck-ai/docs/blob/main/graphql/interfaces/NodePicking.md)
* [PickingOrder Type](/graphql-api/types/pickingorder.md)
* [PickingOrderItem Type](/graphql-api/types/pickingorderitem.md)
* [pickingOrders Query](/graphql-api/queries/pickingorders.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pyck.cloud/graphql-api/queries/nodepicking.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
